#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include "libfleximon.h"

char *respond_disks (char *query)
{
  char *df_command;
  char line [1024] = "";
  char proc [1024] = "";
  int running = 0;
  FILE *df;
  df_command = "df -l -P | grep ^/dev | awk \"{ printf \\\"%s %i %i\\n\\\", \\$6, \\$3/1024, \\$2/1024; }\"";
  df = popen(df_command,"r");
  if (!df) {
    printf("Could not popen(%s): %s\n",df_command,strerror(errno));
    return "ERROR - internal error";
  }
  fgets(line,1023,df);
  while (!feof(df)) {
    line[strlen(line)-1] = 0;
    if (running)
      strcat(proc,"\n");
    strcat(proc,line);
    running++;
    fgets(line,1023,df);
  }
  pclose(df);
  return running ? proc : "NOT RUNNING";
}

FM_PLUGIN("DISKS","Disk, their  usage and capacity (in MB)",respond_disks)
